SystemOrganization addCategory: #'Polymorph-ToolBuilder-Kernel'!
SystemOrganization addCategory: #'Polymorph-ToolBuilder-Morphic'!

PluggablePanelMorph subclass: #PluggableThemedPanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 12:40'!
adoptPaneColor: aColor
	"Set the pane color."
	
	super adoptPaneColor: aColor.
	aColor ifNil: [^self].
	self fillStyle: self normalFillStyle.
	self borderColor: aColor! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/11/2009 17:03'!
color: aColor
	"Set the pane color."
	
	self assureExtension.
	extension fillStyle ifNil: [
		super color: aColor]! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:13'!
extent: aPoint
	"Update the bar fillStyle if appropriate."
	
	super extent: aPoint.
	self fillStyle isOrientedFill ifTrue: [
		self fillStyle: self normalFillStyle]! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 15:09'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		layoutInset: 2;
		cellInset: 4! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:29'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	UITheme ifNil: [^self paneColor].
	^self theme buttonPanelNormalFillStyleFor: self! !

StandardWindow subclass: #PluggableStandardWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PluggableStandardWindow class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:09'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color lightGray! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableStandardWindow methodsFor: 'initialization' stamp: 'gvc 7/30/2009 13:41'!
delete
	"Should be this way around since the window may not close
	for other reasons!!"
	
	|m|
	m := model.
	super delete.
	closeWindowSelector ifNotNil:[m perform: closeWindowSelector]! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getLabelSelector
	^getLabelSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
label
	^label contents! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
label: aString
	self setLabel: aString.! !

!PluggableStandardWindow methodsFor: 'updating' stamp: 'gvc 1/9/2007 13:31'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

MorphicToolBuilder subclass: #PSToolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 18:47'!
buildPluggableButton: aSpec
	"Reset the hardcodes white colour defined in superclass implementation."
	
	^(super buildPluggableButton: aSpec)
		onColor: nil offColor: nil;
		yourself! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 18:09'!
buildPluggableList: aSpec
	"Build an appropriate pluggable list."
	
	| widget |
	aSpec icon
		ifNil: [widget := super buildPluggableList: aSpec]
		ifNotNil: [widget := PluggableIconListMorph new
					getIconSelector: aSpec icon;
					on: aSpec model
					list: aSpec list
					selected: aSpec getIndex
					changeSelected: aSpec setIndex
					menu: aSpec menu
					keystroke: aSpec keyPress.
				self register: widget id: aSpec name.
				widget autoDeselect: aSpec autoDeselect.
				self setFrame: aSpec frame in: widget.
				parent ifNotNil:[self add: widget to: parent].
				panes ifNotNil:[aSpec list ifNotNil:[panes add: aSpec list]]].
	widget doubleClickSelector: aSpec action.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 14:57'!
buildPluggablePanel: aSpec
	"Build a pluggable panel (aka button row!!)."
	
	| widget children row |
	widget := PluggableThemedOverflowPanelMorph new.
	self register: widget id: aSpec name.
	widget
		model: aSpec model;
		fillStyle: widget normalFillStyle;
		clipSubmorphs: true.
	self setLayout: aSpec layout in: widget.
	self setFrame: aSpec frame in: widget.
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #()].
	row := Morph new
		layoutPolicy: RowLayout new;
		hResizing: #spaceFill; vResizing: #shrinkWrap;
		cellInset: widget cellInset;
		layoutInset: widget layoutInset.
	self buildAll: children in: row.
	parent ifNotNil: [self add: widget to: parent].
	widget baseMorph: row.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 2/13/2010 22:32'!
buildPluggableWindow: aSpec
	| widget children label |
	aSpec layout == #proportional ifFalse:[
		"This needs to be implemented - probably by adding a single pane and then the rest"
		^self error: 'Not implemented'.
	].
	widget := PluggableStandardWindow new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	(label := aSpec label) ifNotNil:[
		label isSymbol 
			ifTrue:[widget getLabelSelector: label]
			ifFalse:[widget setLabel: label]].
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	widget closeWindowSelector: aSpec closeAction.
	panes := OrderedCollection new.
	self buildAll: children in: widget.
	"aSpec extent ifNotNil:[widget extent: aSpec extent]."
	self buildHelpFor: widget spec: aSpec. 
	widget bounds: (RealEstateAgent 
		initialFrameFor: widget 
		initialExtent: (aSpec extent ifNil:[widget initialExtent])
		world: self currentWorld).
	
	widget setUpdatablePanesFrom: panes.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 2/13/2010 14:42'!
menuItemClass
	^ ToggleMenuItemMorph! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 17:39'!
pluggableListSpec
	"Answer the spec supporting an action selector (doubleclick)."
	
	^PSPluggableListSpec! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:45'!
chooseFrom: aList lines: linesArray message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: linesArray message: messageString title: ''! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:47'!
chooseFrom: aList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^self
		chooseFrom: aList
		lines: linesArray
		title: (aString 
				ifEmpty: [messageString]
				ifNotEmpty: [aString, String cr, messageString])! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:45'!
chooseFrom: aList message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: #() message: messageString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:44'!
chooseFrom: aList message: messageString title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: #() message: messageString title: aString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:50'!
chooseFrom: aList values: valueList lines: linesArray message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: linesArray message: messageString title: ''! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:52'!
chooseFrom: labelList values: valueList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^self
		chooseFrom: labelList
		values: valueList 
		lines: linesArray
		title: (aString 
				ifEmpty: [messageString]
				ifNotEmpty: [aString, String cr, messageString])! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:49'!
chooseFrom: aList values: valueList message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: #() message: messageString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:50'!
chooseFrom: aList values: valueList message: messageString title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: #() message: messageString title: aString! !

OverflowRowMorph subclass: #PluggableThemedOverflowPanelMorph
	instanceVariableNames: 'model getChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PluggableThemedOverflowPanelMorph methodsFor: 'user interface' stamp: 'gvc 7/1/2010 14:50'!
adoptPaneColor: aColor
	"Set the pane color."
	
	super adoptPaneColor: aColor.
	aColor ifNil: [^self].
	self fillStyle: self normalFillStyle.
	self borderColor: aColor! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:59'!
baseMorphs: aCollection
	"Set the morphs used in the complete contents of the row."

	aCollection do: [:m | m hResizing: #spaceFill; vResizing: #spaceFill].
	super baseMorphs: aCollection! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:50'!
color: aColor
	"Set the pane color."
	
	self assureExtension.
	extension fillStyle ifNil: [
		super color: aColor]! !

!PluggableThemedOverflowPanelMorph methodsFor: 'geometry' stamp: 'gvc 7/1/2010 14:51'!
extent: aPoint
	"Update the bar fillStyle if appropriate."
	
	super extent: aPoint.
	self fillStyle isOrientedFill ifTrue: [
		self fillStyle: self normalFillStyle]! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:48'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:48'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:48'!
model
	^model! !

!PluggableThemedOverflowPanelMorph methodsFor: 'accessing' stamp: 'gvc 7/1/2010 14:48'!
model: aModel
	model ifNotNil: [model removeDependent: self].
	model := aModel.
	model ifNotNil: [model addDependent: self]! !

!PluggableThemedOverflowPanelMorph methodsFor: 'user interface' stamp: 'gvc 7/1/2010 14:53'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme buttonPanelNormalFillStyleFor: self! !

!PluggableThemedOverflowPanelMorph methodsFor: 'updating' stamp: 'gvc 7/1/2010 14:58'!
update: what
	what ifNil: [^self].
	what == getChildrenSelector ifTrue:[
		self baseMorphs: (model perform: getChildrenSelector).
		self fitBaseMorphs]! !

PluggableListSpec subclass: #PSPluggableListSpec
	instanceVariableNames: 'icon action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Kernel'!

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
action
	"Answer the value of action"

	^ action! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
action: anObject
	"Set the value of action"

	action := anObject! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
icon
	"Answer the value of icon"

	^ icon! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !
